diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/rate-control/rrpaa-wifi-manager.cc ns-3.36/src/wifi/model/rate-control/rrpaa-wifi-manager.cc
--- ns-3.35/src/wifi/model/rate-control/rrpaa-wifi-manager.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/rate-control/rrpaa-wifi-manager.cc	2022-04-30 18:23:58.210735000 -0700
@@ -424,7 +424,6 @@
     {
       channelWidth = 20;
     }
-  WifiTxVector rtsTxVector;
   WifiMode mode;
   if (GetUseNonErpProtection () == false)
     {
@@ -434,8 +433,7 @@
     {
       mode = GetNonErpSupported (station, 0);
     }
-  rtsTxVector = WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()), 800, 1, 1, 0, channelWidth, GetAggregation (station));
-  return rtsTxVector;
+  return WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()), 800, 1, 1, 0, channelWidth, GetAggregation (station));
 }
 
 bool
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/reference/error-rate-tables.h ns-3.36/src/wifi/model/reference/error-rate-tables.h
--- ns-3.35/src/wifi/model/reference/error-rate-tables.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/reference/error-rate-tables.h	2022-04-30 18:23:58.210735000 -0700
@@ -31,14 +31,14 @@
 const uint16_t ERROR_TABLE_BCC_SMALL_FRAME_SIZE = 32;   //!< reference size (bytes) of small frames for BCC
 const uint16_t ERROR_TABLE_BCC_LARGE_FRAME_SIZE = 1458; //!< reference size (bytes) of large frames for BCC
 const uint16_t ERROR_TABLE_LDPC_FRAME_SIZE = 1458;      //!< reference size (bytes) for LDPC
-const uint8_t ERROR_TABLE_BCC_MAX_NUM_MCS = 9;          //!< maximum number of MCSs for BCC
-const uint8_t ERROR_TABLE_LDPC_MAX_NUM_MCS = 11;        //!< maximum number of MCSs for LDPC
+const uint8_t ERROR_TABLE_BCC_MAX_NUM_MCS = 10;         //!< maximum number of MCSs for BCC
+const uint8_t ERROR_TABLE_LDPC_MAX_NUM_MCS = 12;        //!< maximum number of MCSs for LDPC
 
 /// Table of SNR (dB) and PER pairs
 typedef std::vector<std::pair<double /* SNR (dB) */, double /* PER */> > SnrPerTable;
 
 /// AWGN error table for BCC with reference size of 32 bytes
-static const SnrPerTable AwgnErrorTableBcc32 [ERROR_TABLE_BCC_MAX_NUM_MCS + 1] = {
+static const SnrPerTable AwgnErrorTableBcc32 [ERROR_TABLE_BCC_MAX_NUM_MCS] = {
   // MCS-0
   {
     {-3.50000, 1.00000}, {-3.00000, 0.99500}, {-2.50000, 0.94080}, {-2.00000, 0.82590},
@@ -116,7 +116,7 @@
 };
 
 /// AWGN error table for BCC with reference size of 1458 bytes
-static const SnrPerTable AwgnErrorTableBcc1458 [ERROR_TABLE_BCC_MAX_NUM_MCS + 1] = {
+static const SnrPerTable AwgnErrorTableBcc1458 [ERROR_TABLE_BCC_MAX_NUM_MCS] = {
   // MCS-0
   {
     {-1.00000, 1.00000}, {-0.50000, 0.99400}, {0.00000, 0.81850}, {0.50000, 0.29080},
@@ -183,7 +183,7 @@
 };
 
 /// AWGN error table for LDPC with reference size of 1458 bytes
-static const SnrPerTable AwgnErrorTableLdpc1458 [ERROR_TABLE_LDPC_MAX_NUM_MCS + 1] = {
+static const SnrPerTable AwgnErrorTableLdpc1458 [ERROR_TABLE_LDPC_MAX_NUM_MCS] = {
   // MCS-0
   {
     {-1.50000, 1.00000}, {-1.25000, 0.97950}, {-1.00000, 0.60480}, {-0.75000, 0.17050},
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/spectrum-wifi-phy.cc ns-3.36/src/wifi/model/spectrum-wifi-phy.cc
--- ns-3.35/src/wifi/model/spectrum-wifi-phy.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/spectrum-wifi-phy.cc	2022-04-30 18:23:58.214735300 -0700
@@ -161,7 +161,7 @@
             }
         }
     }
-  if (GetPhyStandard () >= WIFI_PHY_STANDARD_80211ax)
+  if (GetStandard () >= WIFI_STANDARD_80211ax)
     {
       // For a given RU type, some RUs over a channel occupy the same tones as
       // the corresponding RUs over a subchannel, while some others not. For instance,
@@ -236,43 +236,10 @@
 }
 
 void
-SpectrumWifiPhy::SetChannelNumber (uint8_t nch)
+SpectrumWifiPhy::DoChannelSwitch (void)
 {
-  NS_LOG_FUNCTION (this << +nch);
-  WifiPhy::SetChannelNumber (nch);
-  if (IsInitialized ())
-    {
-      ResetSpectrumModel ();
-    }
-}
-
-void
-SpectrumWifiPhy::SetFrequency (uint16_t freq)
-{
-  NS_LOG_FUNCTION (this << freq);
-  WifiPhy::SetFrequency (freq);
-  if (IsInitialized ())
-    {
-      ResetSpectrumModel ();
-    }
-}
-
-void
-SpectrumWifiPhy::SetChannelWidth (uint16_t channelwidth)
-{
-  NS_LOG_FUNCTION (this << channelwidth);
-  WifiPhy::SetChannelWidth (channelwidth);
-  if (IsInitialized ())
-    {
-      ResetSpectrumModel ();
-    }
-}
-
-void
-SpectrumWifiPhy::ConfigureStandardAndBand (WifiPhyStandard standard, WifiPhyBand band)
-{
-  NS_LOG_FUNCTION (this << standard << band);
-  WifiPhy::ConfigureStandardAndBand (standard, band);
+  NS_LOG_FUNCTION (this);
+  WifiPhy::DoChannelSwitch ();
   if (IsInitialized ())
     {
       ResetSpectrumModel ();
@@ -337,8 +304,8 @@
       rxPowerW.insert ({filteredBand, rxPowerPerBandW});
       NS_LOG_DEBUG ("Signal power received after antenna gain for 20 MHz channel band " << +i << ": " << rxPowerPerBandW << " W (" << WToDbm (rxPowerPerBandW) << " dBm)");
     }
-  
-  if (GetPhyStandard () >= WIFI_PHY_STANDARD_80211ax)
+
+  if (GetStandard () >= WIFI_STANDARD_80211ax)
     {
       NS_ASSERT (!m_ruBands[channelWidth].empty ());
       for (const auto& bandRuPair : m_ruBands[channelWidth])
@@ -356,7 +323,7 @@
   Ptr<WifiSpectrumSignalParameters> wifiRxParams = DynamicCast<WifiSpectrumSignalParameters> (rxParams);
 
   // Log the signal arrival to the trace source
-  m_signalCb (wifiRxParams ? true : false, senderNodeId, WToDbm (totalRxPowerW), rxDuration);
+  m_signalCb (wifiRxParams, senderNodeId, WToDbm (totalRxPowerW), rxDuration);
 
   if (wifiRxParams == 0)
     {
@@ -389,13 +356,6 @@
   // does not overlap with the receiver's primary20 channel
   if (wifiRxParams->txPhy != 0)
     {
-      Ptr<WifiNetDevice> dev = DynamicCast<WifiNetDevice> (rxParams->txPhy->GetDevice ());
-      NS_ASSERT (dev != 0);
-      Ptr<WifiPhy> txPhy = dev->GetPhy ();
-      NS_ASSERT (txPhy != 0);
-      uint16_t txChannelWidth = wifiRxParams->ppdu->GetTxVector ().GetChannelWidth ();
-      uint16_t txCenterFreq = txPhy->GetOperatingChannel ().GetPrimaryChannelCenterFrequency (txChannelWidth);
-
       // if the channel width is a multiple of 20 MHz, then we consider the primary20 channel
       uint16_t width = (GetChannelWidth () % 20 == 0 ? 20 : GetChannelWidth ());
       uint16_t p20MinFreq =
@@ -403,7 +363,7 @@
       uint16_t p20MaxFreq =
           GetOperatingChannel ().GetPrimaryChannelCenterFrequency (width) + width / 2;
 
-      if (!wifiRxParams->ppdu->CanBeReceived (txCenterFreq, p20MinFreq, p20MaxFreq))
+      if (!wifiRxParams->ppdu->CanBeReceived (wifiRxParams->txCenterFreq, p20MinFreq, p20MaxFreq))
         {
           NS_LOG_INFO ("Cannot receive the PPDU, consider it as interference");
           m_interference.Add (wifiRxParams->ppdu, wifiRxParams->ppdu->GetTxVector (),
@@ -418,8 +378,8 @@
   StartReceivePreamble (ppdu, rxPowerW, rxDuration);
 }
 
-Ptr<AntennaModel>
-SpectrumWifiPhy::GetRxAntenna (void) const
+Ptr<Object>
+SpectrumWifiPhy::GetAntenna (void) const
 {
   return m_antenna;
 }
@@ -464,17 +424,17 @@
 SpectrumWifiPhy::GetBandBandwidth (void) const
 {
   uint32_t bandBandwidth = 0;
-  switch (GetPhyStandard ())
+  switch (GetStandard ())
     {
-    case WIFI_PHY_STANDARD_80211a:
-    case WIFI_PHY_STANDARD_80211g:
-    case WIFI_PHY_STANDARD_80211b:
-    case WIFI_PHY_STANDARD_80211n:
-    case WIFI_PHY_STANDARD_80211ac:
+    case WIFI_STANDARD_80211a:
+    case WIFI_STANDARD_80211g:
+    case WIFI_STANDARD_80211b:
+    case WIFI_STANDARD_80211n:
+    case WIFI_STANDARD_80211ac:
       // Use OFDM subcarrier width of 312.5 KHz as band granularity
       bandBandwidth = 312500;
       break;
-    case WIFI_PHY_STANDARD_80211p:
+    case WIFI_STANDARD_80211p:
       if (GetChannelWidth () == 5)
         {
           // Use OFDM subcarrier width of 78.125 KHz as band granularity
@@ -486,12 +446,12 @@
           bandBandwidth = 156250;
         }
       break;
-    case WIFI_PHY_STANDARD_80211ax:
+    case WIFI_STANDARD_80211ax:
       // Use OFDM subcarrier width of 78.125 KHz as band granularity
       bandBandwidth = 78125;
       break;
     default:
-      NS_FATAL_ERROR ("Standard unknown: " << GetPhyStandard ());
+      NS_FATAL_ERROR ("Standard unknown: " << GetStandard ());
       break;
     }
   return bandBandwidth;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/spectrum-wifi-phy.h ns-3.36/src/wifi/model/spectrum-wifi-phy.h
--- ns-3.35/src/wifi/model/spectrum-wifi-phy.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/spectrum-wifi-phy.h	2022-04-30 18:23:58.214735300 -0700
@@ -100,7 +100,7 @@
    *                SpectrumSignalParameters (in case any objects downstream of the
    *                SpectrumWifiPhy wish to adjust signal properties based on the
    *                transmitted antenna model.  This antenna is also used when
-   *                the underlying WifiSpectrumPhyInterface::GetRxAntenna() method
+   *                the underlying WifiSpectrumPhyInterface::GetAntenna() method
    *                is called.
    *
    * Note:  this method may be split into separate SetTx and SetRx
@@ -112,7 +112,7 @@
    *
    * \return the AntennaModel used for reception
    */
-  Ptr<AntennaModel> GetRxAntenna (void) const;
+  Ptr<Object> GetAntenna (void) const;
   /**
    * \return the SpectrumModel that this SpectrumPhy expects to be used
    *         for all SpectrumValues that are passed to StartRx. If 0 is
@@ -135,12 +135,9 @@
    */
   typedef void (* SignalArrivalCallback) (bool signalType, uint32_t senderNodeId, double rxPower, Time duration);
 
-  // The following four methods call to the base WifiPhy class method
-  // but also generate a new SpectrumModel if called during runtime
-  void SetChannelNumber (uint8_t id) override;
-  void SetFrequency (uint16_t freq) override;
-  void SetChannelWidth (uint16_t channelwidth) override;
-  void ConfigureStandardAndBand (WifiPhyStandard standard, WifiPhyBand band) override;
+  // The following method calls the base WifiPhy class method
+  // but also generates a new SpectrumModel if called during runtime
+  void DoChannelSwitch (void) override;
 
   /**
    * This function is sending the signal to the Spectrum channel
